Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 4495)
@@ -3476,298 +3486,552 @@
 
        ENDDO
-!
-!--    Output strings for the total number of upward / downward-facing surfaces 
-!--    on subdomain.
-       CALL wrd_write_string( 'ns_h_on_file' )
-       WRITE ( 14 )  ns_h_on_file
-!
-!--    Output strings for the total number of north/south/east/westward-facing surfaces 
-!--    on subdomain.
-       CALL wrd_write_string( 'ns_v_on_file' )
-       WRITE ( 14 )  ns_v_on_file
-
-!
-!--    Write required restart data.
-!--    Start with horizontal surfaces (upward-, downward-facing, and model top).
-!--    Always start with %start_index followed by %end_index
-       DO  l = 0, 2
-          WRITE( dum, '(I1)')  l
-
-          CALL wrd_write_string( 'surf_h(' // dum // ')%start_index' )
-          WRITE ( 14 )  surf_h(l)%start_index
-
-          CALL wrd_write_string( 'surf_h(' // dum // ')%end_index' )
-          WRITE ( 14 )  surf_h(l)%end_index
-
-          IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%us' ) 
-             WRITE ( 14 )  surf_h(l)%us
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ts ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ts' ) 
-             WRITE ( 14 )  surf_h(l)%ts
-          ENDIF
+
+!
+!--    Now start writing restart data to file
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+!
+!--       Output strings for the total number of upward / downward-facing surfaces
+!--       on subdomain.
+          CALL wrd_write_string( 'ns_h_on_file' )
+          WRITE ( 14 )  ns_h_on_file
+!
+!--       Output strings for the total number of north/south/east/westward-facing surfaces
+!--       on subdomain.
+          CALL wrd_write_string( 'ns_v_on_file' )
+          WRITE ( 14 )  ns_v_on_file
+
+!
+!--       Horizontal surfaces (upward-, downward-facing, and model top).
+!--       Always start with %start_index followed by %end_index
+          DO  l = 0, 2
+             WRITE( dum, '(I1)')  l
+
+             CALL wrd_write_string( 'surf_h(' // dum // ')%start_index' )
+             WRITE ( 14 )  surf_h(l)%start_index
+
+             CALL wrd_write_string( 'surf_h(' // dum // ')%end_index' )
+             WRITE ( 14 )  surf_h(l)%end_index
+
+             IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%us' )
+                WRITE ( 14 )  surf_h(l)%us
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ts ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ts' )
+                WRITE ( 14 )  surf_h(l)%ts
+             ENDIF
           
-          IF ( ALLOCATED ( surf_h(l)%qs ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qs' )  
-             WRITE ( 14 )  surf_h(l)%qs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ss ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ss' )  
-             WRITE ( 14 )  surf_h(l)%ss
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN  
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qcs' )
-             WRITE ( 14 )  surf_h(l)%qcs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ncs' ) 
-             WRITE ( 14 )  surf_h(l)%ncs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN  
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qrs' )
-             WRITE ( 14 )  surf_h(l)%qrs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%nrs ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%nrs' )  
-             WRITE ( 14 )  surf_h(l)%nrs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ol ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ol' )  
-             WRITE ( 14 )  surf_h(l)%ol
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%rib ) )  THEN
-            CALL wrd_write_string( 'surf_h(' // dum // ')%rib' ) 
-             WRITE ( 14 )  surf_h(l)%rib
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%pt_surface ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%pt_surface' ) 
-             WRITE ( 14 )  surf_h(l)%pt_surface
-          ENDIF
+             IF ( ALLOCATED ( surf_h(l)%qs ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qs' )
+                WRITE ( 14 )  surf_h(l)%qs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ss ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ss' )
+                WRITE ( 14 )  surf_h(l)%ss
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qcs' )
+                WRITE ( 14 )  surf_h(l)%qcs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ncs' )
+                WRITE ( 14 )  surf_h(l)%ncs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qrs' )
+                WRITE ( 14 )  surf_h(l)%qrs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nrs ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%nrs' )
+                WRITE ( 14 )  surf_h(l)%nrs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ol ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ol' )
+                WRITE ( 14 )  surf_h(l)%ol
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%rib ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%rib' )
+                WRITE ( 14 )  surf_h(l)%rib
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%pt_surface ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%pt_surface' )
+                WRITE ( 14 )  surf_h(l)%pt_surface
+             ENDIF
           
-          IF ( ALLOCATED ( surf_h(l)%q_surface ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%q_surface' ) 
-             WRITE ( 14 )  surf_h(l)%q_surface
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%vpt_surface ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%vpt_surface' ) 
-             WRITE ( 14 )  surf_h(l)%vpt_surface
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%usws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%usws' ) 
-             WRITE ( 14 )  surf_h(l)%usws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%vsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%vsws' )  
-             WRITE ( 14 )  surf_h(l)%vsws
-          ENDIF
+             IF ( ALLOCATED ( surf_h(l)%q_surface ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%q_surface' )
+                WRITE ( 14 )  surf_h(l)%q_surface
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%vpt_surface ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%vpt_surface' )
+                WRITE ( 14 )  surf_h(l)%vpt_surface
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%usws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%usws' )
+                WRITE ( 14 )  surf_h(l)%usws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%vsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%vsws' )
+                WRITE ( 14 )  surf_h(l)%vsws
+             ENDIF
           
-          IF ( ALLOCATED ( surf_h(l)%shf ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%shf' ) 
-             WRITE ( 14 )  surf_h(l)%shf
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%qsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qsws' )  
-             WRITE ( 14 )  surf_h(l)%qsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN 
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ssws' )  
-             WRITE ( 14 )  surf_h(l)%ssws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%css ) )  THEN 
-             CALL wrd_write_string( 'surf_h(' // dum // ')%css' )
-             WRITE ( 14 )  surf_h(l)%css
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%cssws ) )  THEN 
-             CALL wrd_write_string( 'surf_h(' // dum // ')%cssws' )
-             WRITE ( 14 )  surf_h(l)%cssws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qcsws' )  
-             WRITE ( 14 )  surf_h(l)%qcsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%ncsws' )  
-             WRITE ( 14 )  surf_h(l)%ncsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%qrsws' )  
-             WRITE ( 14 )  surf_h(l)%qrsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%nrsws ) )  THEN
-             CALL wrd_write_string( 'surf_h(' // dum // ')%nrsws' )  
-             WRITE ( 14 )  surf_h(l)%nrsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_h(l)%sasws ) )  THEN 
-             CALL wrd_write_string( 'surf_h(' // dum // ')%sasws' ) 
-             WRITE ( 14 )  surf_h(l)%sasws
-          ENDIF
+             IF ( ALLOCATED ( surf_h(l)%shf ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%shf' )
+                WRITE ( 14 )  surf_h(l)%shf
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qsws' )
+                WRITE ( 14 )  surf_h(l)%qsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ssws' )
+                WRITE ( 14 )  surf_h(l)%ssws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%css ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%css' )
+                WRITE ( 14 )  surf_h(l)%css
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%cssws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%cssws' )
+                WRITE ( 14 )  surf_h(l)%cssws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qcsws' )
+                WRITE ( 14 )  surf_h(l)%qcsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%ncsws' )
+                WRITE ( 14 )  surf_h(l)%ncsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%qrsws' )
+                WRITE ( 14 )  surf_h(l)%qrsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nrsws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%nrsws' )
+                WRITE ( 14 )  surf_h(l)%nrsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%sasws ) )  THEN
+                CALL wrd_write_string( 'surf_h(' // dum // ')%sasws' )
+                WRITE ( 14 )  surf_h(l)%sasws
+             ENDIF
   
-       ENDDO
-!
-!--    Write vertical surfaces.
-!--    Always start with %start_index followed by %end_index.
-       DO  l = 0, 3
-          WRITE( dum, '(I1)')  l
-
-          CALL wrd_write_string( 'surf_v(' // dum // ')%start_index' )
-          WRITE ( 14 )  surf_v(l)%start_index
-
-          CALL wrd_write_string( 'surf_v(' // dum // ')%end_index' )
-          WRITE ( 14 )   surf_v(l)%end_index
-
-          IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%us' )  
-             WRITE ( 14 )  surf_v(l)%us
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%ts ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ts' ) 
-             WRITE ( 14 )  surf_v(l)%ts
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%qs ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qs' )  
-             WRITE ( 14 )  surf_v(l)%qs
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%ss ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ss' ) 
-             WRITE ( 14 )  surf_v(l)%ss
-          ENDIF  
+          ENDDO
+!
+!--       Write vertical surfaces.
+!--       Always start with %start_index followed by %end_index.
+          DO  l = 0, 3
+             WRITE( dum, '(I1)')  l
+
+             CALL wrd_write_string( 'surf_v(' // dum // ')%start_index' )
+             WRITE ( 14 )  surf_v(l)%start_index
+
+             CALL wrd_write_string( 'surf_v(' // dum // ')%end_index' )
+             WRITE ( 14 )   surf_v(l)%end_index
+
+             IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%us' )
+                WRITE ( 14 )  surf_v(l)%us
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ts ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ts' )
+                WRITE ( 14 )  surf_v(l)%ts
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qs ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qs' )
+                WRITE ( 14 )  surf_v(l)%qs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ss ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ss' )
+                WRITE ( 14 )  surf_v(l)%ss
+             ENDIF
           
-          IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qcs' ) 
-             WRITE ( 14 )  surf_v(l)%qcs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN 
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ncs' )
-             WRITE ( 14 )  surf_v(l)%ncs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qrs' )  
-             WRITE ( 14 )  surf_v(l)%qrs
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%nrs ) )  THEN 
-             CALL wrd_write_string( 'surf_v(' // dum // ')%nrs' ) 
-             WRITE ( 14 )  surf_v(l)%nrs
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%ol ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ol' )  
-             WRITE ( 14 )  surf_v(l)%ol
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%rib ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%rib' )
-             WRITE ( 14 )  surf_v(l)%rib
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%pt_surface ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%pt_surface' )
-             WRITE ( 14 )  surf_v(l)%pt_surface
-          ENDIF 
+             IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qcs' )
+                WRITE ( 14 )  surf_v(l)%qcs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ncs' )
+                WRITE ( 14 )  surf_v(l)%ncs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qrs' )
+                WRITE ( 14 )  surf_v(l)%qrs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nrs ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%nrs' )
+                WRITE ( 14 )  surf_v(l)%nrs
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ol ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ol' )
+                WRITE ( 14 )  surf_v(l)%ol
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%rib ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%rib' )
+                WRITE ( 14 )  surf_v(l)%rib
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%pt_surface ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%pt_surface' )
+                WRITE ( 14 )  surf_v(l)%pt_surface
+             ENDIF
           
-          IF ( ALLOCATED ( surf_v(l)%q_surface ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%q_surface' )
-             WRITE ( 14 )  surf_v(l)%q_surface
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%vpt_surface ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%vpt_surface' )
-             WRITE ( 14 )  surf_v(l)%vpt_surface
-          ENDIF 
-
-          IF ( ALLOCATED ( surf_v(l)%shf ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%shf' )  
-             WRITE ( 14 )  surf_v(l)%shf
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%qsws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qsws' )  
-             WRITE ( 14 )  surf_v(l)%qsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ssws' )  
-             WRITE ( 14 )  surf_v(l)%ssws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%css ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%css' )  
-             WRITE ( 14 )  surf_v(l)%css
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%cssws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%cssws' ) 
-             WRITE ( 14 )  surf_v(l)%cssws
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qcsws' ) 
-             WRITE ( 14 )  surf_v(l)%qcsws
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%ncsws' ) 
-             WRITE ( 14 )  surf_v(l)%ncsws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%qrsws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%qrsws' )  
-             WRITE ( 14 )  surf_v(l)%qrsws
-          ENDIF  
-
-          IF ( ALLOCATED ( surf_v(l)%nrsws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%nrsws' )  
-             WRITE ( 14 )  surf_v(l)%nrsws
-          ENDIF 
-
-          IF ( ALLOCATED ( surf_v(l)%sasws ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%sasws' ) 
-             WRITE ( 14 )  surf_v(l)%sasws
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%mom_flux_uv ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_uv' )  
-             WRITE ( 14 )  surf_v(l)%mom_flux_uv
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%mom_flux_w ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_w' ) 
-             WRITE ( 14 )  surf_v(l)%mom_flux_w
-          ENDIF
-
-          IF ( ALLOCATED ( surf_v(l)%mom_flux_tke ) )  THEN
-             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_tke' )  
-             WRITE ( 14 )  surf_v(l)%mom_flux_tke
-          ENDIF 
-         
-       ENDDO
-
+             IF ( ALLOCATED ( surf_v(l)%q_surface ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%q_surface' )
+                WRITE ( 14 )  surf_v(l)%q_surface
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%vpt_surface ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%vpt_surface' )
+                WRITE ( 14 )  surf_v(l)%vpt_surface
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%shf ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%shf' )
+                WRITE ( 14 )  surf_v(l)%shf
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qsws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qsws' )
+                WRITE ( 14 )  surf_v(l)%qsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ssws' )
+                WRITE ( 14 )  surf_v(l)%ssws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%css ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%css' )
+                WRITE ( 14 )  surf_v(l)%css
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%cssws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%cssws' )
+                WRITE ( 14 )  surf_v(l)%cssws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qcsws' )
+                WRITE ( 14 )  surf_v(l)%qcsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%ncsws' )
+                WRITE ( 14 )  surf_v(l)%ncsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qrsws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%qrsws' )
+                WRITE ( 14 )  surf_v(l)%qrsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nrsws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%nrsws' )
+                WRITE ( 14 )  surf_v(l)%nrsws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%sasws ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%sasws' )
+                WRITE ( 14 )  surf_v(l)%sasws
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_uv ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%mom_uv' )
+                WRITE ( 14 )  surf_v(l)%mom_flux_uv
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_w ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%mom_w' )
+                WRITE ( 14 )  surf_v(l)%mom_flux_w
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_tke ) )  THEN
+                CALL wrd_write_string( 'surf_v(' // dum // ')%mom_tke' )
+                WRITE ( 14 )  surf_v(l)%mom_flux_tke
+             ENDIF
+
+          ENDDO
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!
+!--       Start with horizontal surfaces (upward-, downward-facing, and model top).
+!--       All data writen with rd_mpi_io_write_surface are globally indexed 1d-arrays.
+          ns_h_on_file = 0
+          ns_v_on_file = 0
+
+          DO  l = 0, 2
+
+             WRITE( dum, '(I1)')  l
+
+             CALL rd_mpi_io_surface_filetypes( surf_h(l)%start_index, surf_h(l)%end_index,         &
+                                               surface_data_to_write, global_start_index )
+             IF ( .NOT. surface_data_to_write )  CYCLE
+
+             ns_h_on_file(l) = total_number_of_surface_values
+
+             CALL wrd_mpi_io( 'surf_h(' // dum // ')%start_index',  surf_h(l)%start_index )
+             CALL wrd_mpi_io( 'surf_h(' // dum // ')%end_index',  surf_h(l)%end_index )
+             CALL wrd_mpi_io( 'global_start_index_h_' // dum , global_start_index )
+
+             IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
+                CALL wrd_mpi_io_surface ( 'surf_h(' // dum // ')%us', surf_h(l)%us )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ts ) )  THEN
+                CALL wrd_mpi_io_surface ( 'surf_h(' // dum // ')%ts', surf_h(l)%ts )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qs ) )  THEN
+                CALL wrd_mpi_io_surface ( 'surf_h(' // dum // ')%qs', surf_h(l)%qs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ss ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ss', surf_h(l)%ss )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qcs', surf_h(l)%qcs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ncs', surf_h(l)%ncs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qrs', surf_h(l)%qrs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nrs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%nrs', surf_h(l)%nrs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ol ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ol', surf_h(l)%ol )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%rib ) )  THEN
+               CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%rib',  surf_h(l)%rib )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%pt_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%pt_surface', surf_h(l)%pt_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%q_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%q_surface', surf_h(l)%q_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%vpt_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%vpt_surface', surf_h(l)%vpt_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%usws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%usws', surf_h(l)%usws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%vsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%vsws', surf_h(l)%vsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%shf ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%shf', surf_h(l)%shf )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qsws', surf_h(l)%qsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ssws', surf_h(l)%ssws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%css ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%css', surf_h(l)%css )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%cssws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%cssws', surf_h(l)%cssws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qcsws', surf_h(l)%qcsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%ncsws', surf_h(l)%ncsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%qrsws', surf_h(l)%qrsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%nrsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%nrsws', surf_h(l)%nrsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_h(l)%sasws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_h(' // dum // ')%sasws', surf_h(l)%sasws )
+             ENDIF
+
+          ENDDO
+!
+!--       Write vertical surfaces
+          DO  l = 0, 3
+
+             WRITE( dum, '(I1)')  l
+
+             CALL rd_mpi_io_surface_filetypes( surf_v(l)%start_index, surf_v(l)%end_index,         &
+                                               surface_data_to_write, global_start_index )
+
+             ns_v_on_file(l) = total_number_of_surface_values
+
+             CALL wrd_mpi_io( 'surf_v(' // dum // ')%start_index', surf_v(l)%start_index )
+             CALL wrd_mpi_io( 'surf_v(' // dum // ')%end_index', surf_v(l)%end_index )
+             CALL wrd_mpi_io( 'global_start_index_v_' // dum , global_start_index )
+
+             IF ( .NOT. surface_data_to_write )  CYCLE
+
+             IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%us',  surf_v(l)%us )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ts ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ts', surf_v(l)%ts )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qs',  surf_v(l)%qs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ss ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ss',  surf_v(l)%ss )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qcs', surf_v(l)%qcs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ncs', surf_v(l)%ncs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qrs', surf_v(l)%qrs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nrs ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%nrs', surf_v(l)%nrs )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ol ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ol', surf_v(l)%ol )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%rib ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%rib', surf_v(l)%rib )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%pt_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%pt_surface', surf_v(l)%pt_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%q_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%q_surface', surf_v(l)%q_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%vpt_surface ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%vpt_surface', surf_v(l)%vpt_surface )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%shf ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%shf', surf_v(l)%shf )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qsws', surf_v(l)%qsws )
+              ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ssws', surf_v(l)%ssws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%css ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%css', surf_v(l)%css )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%cssws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%cssws', surf_v(l)%cssws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qcsws', surf_v(l)%qcsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%ncsws', surf_v(l)%ncsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%qrsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%qrsws', surf_v(l)%qrsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%nrsws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%nrsws', surf_v(l)%nrsws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%sasws ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%sasws', surf_v(l)%sasws )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_uv ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_uv', surf_v(l)%mom_flux_uv )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_w ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_w',  surf_v(l)%mom_flux_w )
+             ENDIF
+
+             IF ( ALLOCATED ( surf_v(l)%mom_flux_tke ) )  THEN
+                CALL wrd_mpi_io_surface( 'surf_v(' // dum // ')%mom_tke', surf_v(l)%mom_flux_tke )
+             ENDIF
+
+          ENDDO
+
+          CALL wrd_mpi_io_global_array( 'ns_h_on_file', ns_h_on_file )
+          CALL wrd_mpi_io_global_array( 'ns_v_on_file', ns_v_on_file )
+
+       ENDIF
 
     END SUBROUTINE surface_wrd_local
